﻿#Region "FileHeader"
#If False Then ' -------------- FileDescription --------------
DataTableAttach feuert 3 vorgefertigte LoadingEventargs, für die mittm Ladevorgang zusammenhängenden Binding-Suspendierungs-Zustände: Started, BeforeEnd, Ended
Die Info kann sehr variantenreich abgerufen werden, als Boolean oder direkt den LoadState, und die Sub TriDecide führt ByRef eine Zuweisung aus (oder auch nicht), abhängig vom LoadState
Mit TriDecide() können WithEvents-Variablen temporär auf Nothing gesetzt werden, um all deren Events auf einen Schlag zu suspendieren.
#End If
#End Region 'FileHeader

Namespace System.Data

   Partial Public Class DataTableAttach

      Public Class SuspendingEventArgs : Inherits EventArgs
         Public Sub New(state As Suspendstate, what As Suspend)
            Me.Suspended = what
            Me.Suspendstate = state
            Me.Started = state = Data.Suspendstate.Started
            Me.Ended = state = Data.Suspendstate.Ended
            Me.BeforeEnd = state = Data.Suspendstate.BeforeEnd
            StartOrFinish = Not BeforeEnd
         End Sub
         Public ReadOnly Started, Ended, BeforeEnd, StartOrFinish As Boolean
         Public ReadOnly Suspendstate As Suspendstate
         Public ReadOnly Suspended As Suspend

         ''' <summary> Zuweisung an toChange je nach Loadstate, bei .Started: startedValue, .Ended: endedValue, .BeforeEnd: keine Aktion </summary>
         Public Sub TriDecide(Of T As Class)(ByRef toChange As T, startedValue As T, endedValue As T)
            If BeforeEnd Then Return
            toChange = If(Started, startedValue, endedValue)
         End Sub
      End Class 'LoadingEventArgs

      Public Event Suspending As EventHandler(Of SuspendingEventArgs)

   End Class 'DataTableAttach
End Namespace
